; Textbox
; A rectangle housing a stringinput.
;
; Functions:
; 1. guiDrawTextBox
; 2. guiShowTextBox
; 3. guiHideTextBox
; 4. guiInputTextBox			Input text to the textbox.
;
; Comments:
;  The rectangle is drawn one pixel up and two left of the row/col coordinates,
;   so that the text is exactly on the coordinates.
;

TB_Inverse			equ	0
TB_NoBorder			equ	1
TB_Showing			equ	2
TB_Focusable		equ	3

guiShowTextBox:
 inc hl
 inc hl
 set TB_Showing,(hl)
 dec hl
 dec hl
 jr guiDrawTextBox

guiHideTextBox:
 inc hl
 inc hl
 res TB_Showing,(hl)
 dec hl
 dec hl

guiDrawTextBox:
 res plotLoc,(iy+plotflags)
 ld e,(hl)
 inc hl
 ld d,(hl)
 inc hl
 bit TB_Showing,(hl)
 jr z,guiEraseTextBox
 push hl
 pop ix
 inc hl
 inc hl
 inc hl
 ld a,(hl)
 push hl
 inc hl
 ld h,(hl)
 ld l,a
 ld (pencol),hl
 dec h
 dec l
 dec l
 push hl
 add hl,de
 ex de,hl
 pop hl
 push hl
 push de
 push ix
 B_CALL _clearrect
 pop ix
 pop de
 pop hl
 res textinverse,(iy+textflags)
 bit TB_NoBorder,(ix)
 jr nz,guiDrawTextBoxNoBorder
 push hl
 push de
 push ix
 B_CALL _drawrectborderc
 pop ix
 pop de
 pop hl
guiDrawTextBoxNoBorder:
 bit TB_Inverse,(ix)
 jr z,guiDrawTextBoxNoInvert
 push ix
 B_CALL _invertrect
 pop ix
 set textinverse,(iy+textflags)
guiDrawTextBoxNoInvert:
 pop hl
 inc hl
 inc hl
 ld a,(hl)
 inc hl
 ld h,(hl)
 ld l,a
 res fracDrawLFont,(iy+fontFlags)
 bit SI_BigFont,(ix+1)
 jr z,guiDrawTextBoxSmall
 set fracDrawLFont,(iy+fontFlags)
guiDrawTextBoxSmall:
 call vputs2
 res textinverse,(iy+textflags)
 res fracDrawLFont,(iy+fontFlags)
 ret

guiEraseTextBox:
 ld b,(hl)
 inc hl
 inc hl
 inc hl
 ld a,(hl)
 inc hl
 ld h,(hl)
 ld l,a
 dec h
 dec l
 dec l
 push hl
 add hl,de
 ex de,hl
 pop hl
 bit TB_Inverse,b
 jr nz,guiEraseTextBoxFill
 B_CALL _clearrect
 ret
guiEraseTextBoxFill:
 B_CALL _fillrect
 ret

guiInputTextBox:
 inc hl
 inc hl
 res textinverse,(iy+textflags)
 bit TB_Inverse,(hl)
 jr z,guiInputTextBoxNotInverse
 set textinverse,(iy+textflags)
guiInputTextBoxNotInverse:
 inc hl
 jp guiStringInputST


guiHandleTextBox:
 push hl
 pop ix
 ld c,(hl)
 inc hl
 ld b,(hl)
 inc hl
 bit TB_Showing,(hl)
 ret z
 bit TB_Focusable,(hl)
 ret z
 inc hl
 inc hl
 inc hl
 ld a,(hl)
 inc hl
 ld h,(hl)
 ld l,a
 dec h
 dec l
 dec l
 push hl
 add hl,bc
 pop bc
 call IsInRectangle
 ret c
 push ix
 pop hl
 call guiInputTextBox
 jp guiHandleClickFinished